/**
* user:  C001
* fname: Димо Димитров Терзиев
* lname: БЛАГОЕВГРАД
* task:  dmaze
* score: 0.0
* date:  2019-05-11 09:43:02.130697
*/
#include<iostream>
#include<vector>
#include<queue>
#include<algorithm>
using namespace std;

void dejkstra2(vector<int> &v, vector<pair<int, int> > &rezults, int a, int N, int M)
{
  priority_queue<pair<int, int> > q;
  q.push(make_pair(a, 1));
  int maxt=0, maxp;
  while(!q.empty())
   {
     int time=q.top().second, p=q.top().first;
     q.pop();

     if(p%M!=1 && v[p-1]!=-1)
      {
         q.push(make_pair(p-1, time+1));
         if(v[p-1]<time+1)
            v[p-1]=time+1;
      }
     if(p>M && v[p-M]!=-1)
      {
         q.push(make_pair(p-M, time+1));
            if(v[p-M]<time+1)
             v[p-M]=time+1;

      }
     if(p>M && p%M!=1 && v[p-M-1]!=-1)
      {
         q.push(make_pair(p-M-1, time+1));
            if(v[p-M-1]<time+1)
             v[p-M-1]=time+1;
      }
   }
}

void dejkstra(vector<int> v, vector<pair<int, int> > &rezults, int a, int N, int M)
{
  priority_queue<pair<int, int> > q;
  q.push(make_pair(a, 1));
  int maxt=0, maxp;
  while(!q.empty())
   {
     int time=q.top().second, p=q.top().first;
     q.pop();

     if(p<=M*(N-1) && v[p+M]!=-1)
      {
      //   cout << p+M << " " << time+1 << endl;
         q.push(make_pair(p+M, time+1));

      }
     if(p%M!=0 && v[p+1]!=-1)
      {
         //          cout << p+1 << " " << time+1 << endl;
         q.push(make_pair(p+1, time+1));

      }
     if(p<=M*(N-1) && p%M!=0 && v[p+M+1]!=-1)
      {
       //   cout << p+M+1 << " " << time+1 << endl;
         q.push(make_pair(p+M+1, time+1));

      }
    if(time>maxt)
      {
         maxt=time;
         maxp=p;
      }
   }
        //cout << endl;
 // cout << maxt << " " << maxp << endl;
  rezults.push_back(make_pair(maxt, maxp));
}

int main()
{
    vector<pair<int, int> > rezults;
   int M, N, K;
   cin >> M >> N >> K;
   int p, q, a, b, c;
   cin >> p >> q >> a >> b >> c;

   vector<int> vec;
   vec.resize((N)*(M)+1);

   for(int i=1; i<=M; i++)
    for(int v=1; v<=N; v++)
     vec[v+(i-1)*M]=0;

   for(int i=0; i<p; i++)
    {
       vec[q]=-1;

       q=((q*a+b)%c)+1;
    }

   for(int i=1; i<=M; i++)
    for(int v=1; v<=N; v++)
     {
        if(vec[v+(i-1)*M]!=-1)
        {
            int number=v+(i-1)*M;
            dejkstra(vec, rezults, number, N, M);
        }
     }
   sort(rezults.rbegin(), rezults.rend());

   if(rezults[0].second<K)
    cout << -1;
   else
   {

   cout << rezults[0].first << endl;
   int startp=rezults[0].second;

   dejkstra2(vec, rezults, startp, N, M);

  int maxn=0;
   for(int i=0; i<vec.size(); i++)
    {
        if(vec[i]>maxn)
         {
            maxn=vec[i];
            p=i;

         }
    }


   cout << p << " ";
   int maxn2=maxn;
   for(int i=0; i<maxn2; i++)
   {
    //  cout << M*(N-1) << " ";
      if(p<=M*(N-1) && vec[p+M]!=-1 && vec[p+M]==maxn-1)
      {
         cout << p+M << " ";
         p=p+M;
      }
     else if(p%M!=0 && vec[p+1]!=-1 && vec[p+1]==maxn-1)
      {
         cout << p+1 << " ";
         p=p+1;
      }
     else if(p<=M*(N-1) && p%M!=0 && vec[p+M+1]!=-1 && vec[p+1+M]==maxn-1)
      {
         cout << p+1+M << " ";
         p=p+1+M;
      }
      maxn--;
   }
   }
}
