/**
* user:  C036
* fname: Благо Ивов Гунев
* lname: СОФИЯ
* task:  points
* score: 0.0
* date:  2019-05-11 09:07:26.552907
*/
#include<iostream>
#include<algorithm>
#include<vector>
#include<queue>
using namespace std;
int n;
long long x, y;
priority_queue<int> ans;

struct po
{
    long long x;
    long long y;
    int ind;

    bool operator < (po A) const{
        return x*A.y < A.x*y;
    }

};

vector<po> point;
vector<int> drawn;
vector<po> outp;
bool used[1510];

int bin_search(long long x, long long y)
{
    int l, r;
    r = n-1;
    while(l != r){
        int mid = l + (r-l)/2;
        if(x*point[mid].y > y*point[mid].x){
            l = mid+1;
        }else{
            r = mid;
        }
    }
    //cout << l << endl;
    if(x == point[l].x && y == point[l].y){
        return l;
    }else{
        return -1;
    }
}

void recur(int curr, int l, int r)
{
    //cout << "entered" << endl;
    drawn.push_back(curr);
    used[curr] = true;
    if(curr != n-1){
        if(l > r){
            outp.push_back({point[curr].ind, r, l});
        }else{
            outp.push_back({point[curr].ind, l, r});
        }
    }
    long long newx, newy;
    for(int i = 0; i < drawn.size(); i++){
        int d = drawn[i];
        if(curr == d){
            continue;
        }
        int gcd = __gcd(point[curr].y, point[d].y);
        newy = point[curr].y*point[d].y/gcd;
        newx = (point[curr].x*point[d].y/gcd + point[d].x*point[curr].y/gcd);
        if(newx % 2 == 1){
            newy *= 2;
        }else{
            newx /= 2;
        }
        int newind = bin_search(newx, newy);
        //cout << newx << " " << newy << " " << newind << endl;
        if(newind != -1 && !used[newind]){
            recur(newind, point[curr].ind, point[d].ind);
        }
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    for(int i = 1; i <= n; i++){
        cin >> x >> y;
        point.push_back({x, y, i});
    }
    sort(point.begin(), point.end());
    drawn.push_back(0);

    used[0] = true;

    recur(n-1, -1, -1);

    if(drawn.size() < n){
        cout << "NO\n";
        for(int i = 0; i < n; i++){
            if(!used[i]){
                ans.push(-point[i].ind);
            }
        }
        cout << n - drawn.size() << endl;
        while(!ans.empty()){
            cout << -ans.top() << " ";
            ans.pop();
        }
        cout << endl;
        return 0;
    }
    cout << "YES\n";
    for(int i = 0; i < outp.size(); i++){
        cout << outp[i].x << " " << outp[i].y << " " << outp[i].ind << endl;
    }
return 0;
}
/*
4
0 1
1 4
1 2
1 1
*/
