/**
* user:  C039
* fname: Велислав Петров Гърков
* lname: СОФИЯ
* task:  points
* score: 4.0
* date:  2019-05-11 09:20:08.777597
*/
#include <iostream>
#include <algorithm>
using namespace std;
struct Point {
    long long p, q;
    int ind;
};
Point p[1501];
int seq[1501], br, ans[1501][4];
bool no[1501], isPos;
long long NOD(long long a, long long b) {
    long long r;
    while (b>0) {
        r=a%b;
        a=b;
        b=r;
    }
    return a;
}
long long NOK(long long a, long long b) {
    return a*b/NOD(a,b);
}
bool cmp(Point a, Point b) {
    if (a.q!=b.q) return a.q<b.q;
    return a.p<b.p;
}
bool cmpP(int i1, int i2) {
    long long k=NOK(p[i1].q,p[i2].q);
    long long a1, a2;
    a1=p[i1].p*(k/p[i1].q);
    a2=p[i2].p*(k/p[i2].q);
    return a1<a2;
}
bool middle(int l, int r, int ind) {
    long long p1, q1, d;
    q1=max(p[l].q,p[r].q)*2;
    p1=p[l].p*((q1/2)/p[l].q)+p[r].p*((q1/2)/p[r].q);
    d=NOD(p1,q1);
    p1/=d;
    q1/=d;
    return (p[ind].p==p1 && p[ind].q==q1);
}
void findP(int ind) {
    if (p[ind].q==1) {
        seq[br]=ind;
        br++;
        return;
    }
    int l, r;
    bool is=false;
    l=0; r=0;
    while (r<br && l<br) {
        if (cmpP(seq[r],ind)) r++;
        else {
            if (middle(seq[l],seq[r],ind)) {
                is=true;
                ans[br-2][0]=p[ind].ind;
                ans[br-2][1]=p[seq[l]].ind;
                ans[br-2][2]=p[seq[r]].ind;
                break;
            } else l++;
        }
    }
    if (is) {
        seq[br]=ind;
        br++;
        sort(seq,seq+br,cmpP);
    } else {
        no[p[ind].ind]=true;
        isPos=false;
    }
}
int main () {
    int n;
    long long d;
    cin >> n;
    for (int i=0;i<n;i++) {
        cin >> p[i].p >> p[i].q;
        if (p[i].p==0) p[i].q=1;
        else {
            d=NOD(p[i].p,p[i].q);
            p[i].p/=d;
            p[i].q/=d;
        }
        p[i].ind=i;
    }
    sort(p,p+n,cmp);
    long long st=1;
    isPos=true;
    for (int i=0;i<n;i++) {
        if (p[i].q>st) st*=2;
        if (p[i].q!=st) {
            no[p[i].ind]=true;
            isPos=false;
        } else findP(i);
    }
    if (isPos) {
        cout << "YES\n";
        for (int i=0;i<n-2;i++) {
            cout << ans[i][0]+1 << ' ' << ans[i][1]+1 << ' ' << ans[i][2]+1 << endl;
        }
    } else {
        cout << "No\n";
        for (int i=0;i<n;i++) {
            if (no[i]) cout << i+1 << ' ';
        }
        cout << endl;
    }
    return 0;
}
/**
6
3 8
1 2
3 4
1 4
0 1
1 1
**/
