/**
* user:  C052
* fname: Юлиян Радославов Славчев
* lname: СОФИЯ
* task:  dmaze
* score: 80.0
* date:  2019-05-11 07:25:11.108242
*/
#include <bits/stdc++.h>
using namespace std;
typedef long long lon;
#define endl '\n'
#define MAXBR (lon) 9e6 + 5
bool check[MAXBR];
lon table[3005][3005];
lon type[3005][3005];
const lon GO_LEFT = 0;
const lon GO_UP = 1;
const lon GO_DIAGONAL = 2;
const lon END = 3;
pair<lon, lon> dirs[] = {{-1, 0}, {0, -1}, {-1, -1}};
lon rows, cols, p, k, q, a, b, c;
bool exist(lon a, lon b){
    return a >= 0 && b >= 0 && a < rows && b < cols;
}
lon to_number(lon a, lon b){
    return a + 1 + b * rows;
}
vector<lon> path;
int main(){
    cin.tie(0);
    ios::sync_with_stdio(false);
    cin >> rows >> cols >> k >> p >> q >> a >> b >> c;
    check[q] = 1;
    for(lon i = 0; i < p - 1; ++i){
        lon next = ((q * a + b) % c) + 1;
        q = next;
        check[q] = 1;
    }
    lon globalmax = 0;
    pair<lon, lon> maxindex = {5000, 5000};
    for(lon i = 0; i < rows; ++i){
        for(lon z = 0; z < cols; ++z){
            if(check[to_number(i, z)]) continue;
            lon maximum = 0;
            lon maxdir = END;
            for(lon l = 0; l < 3; ++l){
                lon ni = i + dirs[l].first, nz = z + dirs[l].second;
                if(check[to_number(ni, nz)]) continue;
                if(exist(ni, nz)){
                    if(table[ni][nz] > maximum){
                        maximum = table[ni][nz];
                        if(l == 0) maxdir = GO_UP;
                        if(l == 1) maxdir = GO_LEFT;
                        if(l == 2) maxdir = GO_DIAGONAL;
                    }
                }
            }
            ++maximum;
            //cout << maximum << ' ' << maxdir << ' ' << i << ' ' << z << ' ' << to_number(i, z) << endl;
            table[i][z] = maximum;
            type[i][z] = maxdir;
            if(maximum == globalmax && to_number(i, z) < to_number(maxindex.first, maxindex.second)){
                maxindex = {i, z};
            }
            if(maximum > globalmax) maxindex = {i, z};
            globalmax = max(globalmax, maximum);
        }
    }
    if(globalmax < k){
        cout << -1 << endl;
        return 0;
    }
    cout << globalmax << endl;
    while(true){
        path.push_back(to_number(maxindex.first, maxindex.second));
        if(type[maxindex.first][maxindex.second] == GO_UP) --maxindex.first;
        else if(type[maxindex.first][maxindex.second] == GO_LEFT) --maxindex.second;
        else if(type[maxindex.first][maxindex.second] == GO_DIAGONAL){
            --maxindex.first; --maxindex.second;
        }
        else if(type[maxindex.first][maxindex.second] == END) break;
    }
    for(lon i = path.size() - 1; i >= 0; --i){
        cout << path[i] << ' ';
    }
    cout << endl;
    return 0;
}