/**
* user:  C054
* fname: Михаил Петков Михов
* lname: СТ. ЗАГОРА
* task:  travel
* score: 4.0
* date:  2019-05-11 07:47:04.490255
*/
#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using std::cin;
using std::cout;
using std::vector;
using std::pair;
using std::unordered_map;
using std::for_each;

vector<uint32_t> find_path(pair<uint32_t, uint32_t> rel, pair<uint32_t, uint32_t> req);

struct graph{
  graph(uint32_t v, vector<pair<uint32_t, uint32_t> >& rel) : m_v(v) {
    for(int i = 0; i < rel.size(); i++) {
      m_r[rel[i].first].push_back(rel[i].second);
      m_r[rel[i].second].push_back(rel[i].first);
    }
  }
  vector<uint32_t> find_path(uint32_t u, uint32_t v) {
    vector<uint32_t> path {u};
    for(uint32_t& i : m_r[u]) {
      if(i == v) {
        path.push_back(i);
        //cout << "path.size() = " << path.size() << '\n';
        //for(int32_t i = 0; i < path.size(); i++) {
        //  cout << path[i] << "->";
        //}
        //cout << '\n';
        return path;
      }
    }
  }
private:
  const uint32_t m_v;
  unordered_map<uint32_t, vector<uint32_t> > m_r;
};

int main() {

  uint16_t n, m;
  cin >> n >> m;

  vector<pair<uint32_t, uint32_t> > rel(n-1);
  vector<pair<uint32_t, uint32_t> > req(m);

  for(int16_t i = 0; i < n-1; i++) {
    cin >> rel[i].first >> rel[i].second;
  }
  for(int16_t i = 0; i < m; i++) {
    cin >> req[i].first >> req[i].second;
  }

  graph g(n, rel);

  for(pair<uint32_t, uint32_t>& i : req){
    //cout << "i.first = " << i.first << '\n' << "i.second = " << i.second << '\n';
    vector<uint32_t> r = g.find_path(i.first, i.second);
    cout << r[1] << '\n';
  }

  return 0;

}
