/**
* user:  C019
* fname: Емил Иво Рибарев
* lname: ГАБРОВО
* task:  travel
* score: 8.0
* date:  2019-05-11 06:58:21.968575
*/
#include <iostream>
#include <vector>
using namespace std;
struct node{
    int level;
    vector <int> ancestors;
};
vector <int> graph[100022];
node nodes[100022];
int n, m;
void init()
{
    int from, to, fromSize;
    cin>>n>>m;
    for (int i=0; i<n-1; i++){
        cin>>from>>to;
        if (from>to) swap(from, to);
        fromSize=nodes[from].ancestors.size();
        graph[from].push_back(to);
        graph[to].push_back(from);
        nodes[to].ancestors.push_back(from);
        nodes[to].level=nodes[from].level+1;
        for (int i=0; i<fromSize; i++){
            nodes[to].ancestors.push_back(nodes[from].ancestors[i]);
        }
    }
}
void query()
{
    int from, to, toSize;
    cin>>from>>to;
    if (nodes[from].level!=nodes[to].level){
        if (nodes[to].ancestors[0]==from){
            cout<<to<<endl;
            return;
        }
        toSize=nodes[to].ancestors.size();
        for (int i=1; i<toSize; i++){
            if (nodes[to].ancestors[i]==from){
                cout<<nodes[to].ancestors[i-1]<<endl;
                return;
            }
        }
        cout<<nodes[from].ancestors[0]<<endl;
    }
    else cout<<nodes[from].ancestors[0]<<endl;
}
int main()
{
    init();
    /*for (int i=1; i<=n; i++){
        cout<<i<<" -> level: "<<nodes[i].level<<" | anc: ";
        for (int j=0; j<nodes[i].ancestors.size(); j++){
            cout<<nodes[i].ancestors[j]<<"; ";
        }
        cout<<endl;
    }//*/
    for (int i=0; i<m; i++){
        query();
    }
    
    return 0;
}
/**
6 4
1 2
3 2
4 2
2 5
5 6
1 5
4 6
5 6
6 3
*/
