/**
* user:  C035
* fname: Атанас Димитров Димитров
* lname: СОФИЯ
* task:  dmaze
* score: 80.0
* date:  2019-05-11 07:07:22.129844
*/
#include <bits/stdc++.h>
using namespace std;
//#pragma GCC optimize ("O3")
//#pragma GCC target ("sse4")
#define endl "\n"
#define sz(x) ((int)x.size())
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define F first
#define S second
typedef long long ll;
typedef unsigned long long ull;

bool grid[3001][3001];
int dp[3001][3001], last[3001][3001], nxt[3001][3001];
ll bestans, bestind, lastind;
int n, m, k, a, b, c, p, q;

struct Next {
    int dist, last, nxt;
    bool operator <(Next other) const {
        if(dist != other.dist) {return dist < other.dist;}
        return last > other.last;
    }
};

void ans (ll y, ll x) {
    if(y > m || x > n) {return;}
    if(dp[y][x] != 0) {return;}
    if(grid[y][x]) {return;}
    ans(y + 1, x);
    ans(y + 1, x + 1);
    ans(y, x + 1);
    Next curr[5];
    curr[0] = {dp[y][x + 1], last[y][x + 1], y + x * m};
    curr[1] = {dp[y + 1][x + 1], last[y + 1][x + 1], (y + 1) + x * m};
    curr[2] = {dp[y + 1][x], last[y + 1][x], (y + 1) + (x - 1) * m};
    sort(curr, curr + 3);
    dp[y][x] = curr[2].dist + 1;
    last[y][x] = curr[2].last;
    nxt[y][x] = curr[2].nxt;
    if(dp[y][x] == 1) {nxt[y][x] = -1; last[y][x] = y + (x - 1) * m;}
    if(dp[y][x] > bestans) {
        bestans = dp[y][x];
        bestind = y + (x - 1) * m;
        lastind = last[y][x];
    } else if(dp[y][x] == bestans && last[y][x] < lastind) {
        bestans = dp[y][x];
        bestind = y + (x - 1) * m;
        lastind = last[y][x];
    }
    //cout << dp[y][x] << " " << nxt[y][x] << " " << last[y][x] << " " << y << " " << x << " " << y + (x - 1) * m << endl;
    return;
}

void dis(int curr) {
    while(curr != -1) {
        cout << curr << " ";
        curr = nxt[(curr - 1) % m + 1][((curr - 1) / m) + 1];
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> m >> n >> k >> p >> q >> a >> b >> c;
    for(int i = 0; i < p; i ++ ) {
        grid[(q - 1) % m + 1][((q - 1) / m) + 1] = true;
        q = ((q * a + b) % c) + 1;
    }
    for(int i = m; i >= 1; i --) {
        for(int j = n; j >= 1; j --) {
            ans(i, j);
        }
    }
    cout << bestans << endl;
    dis(bestind);
    return 0;
}


