/**
* user:  C036
* fname: Благо Ивов Гунев
* lname: СОФИЯ
* task:  dmaze
* score: 20.0
* date:  2019-05-11 06:41:04.447114
*/
#include<iostream>
#include<vector>
#include<stack>
using namespace std;
int n, m, k;
int path_lenght, lastV;
long long p, q, a, b, c;
vector<int> sys[3100];
stack<int> izh;

bool isBlocked[9000200];
int previ[3010][3010];
int greatest[3010];
//bool used[]

void dfs(int u, int pl, int pre)
{
    if(greatest[u] > pl){
        return;
    }
    previ[u][pl] = pre;
    if(pl > path_lenght){
        path_lenght = pl;
        lastV = u;
    }
    if(greatest[u] < pl){
        greatest[u] = pl;
    }
    for(int j = 0; j < sys[u].size(); j++){
        dfs(sys[u][j], pl+1, u);
    }
}

void path_find(int curr, int pl)
{
    if(pl == 0){
        return;
    }
    izh.push(curr);
    path_find(previ[curr][pl], pl-1);
}

int main(){
    path_lenght = -1;
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> m >> n >> k;
    cin >> p >> q >> a >> b >> c;
    isBlocked[q] = true;
    for(int i = 1; i < p; i++){
        q = ((q*a+b)%c)+1;
        isBlocked[q] = true;
    }
    for(int i = 1; i < n*m; i++){
        if(i%m != 0 && !isBlocked[i+1]){
            sys[i].push_back(i+1);
        }
        if(i+m <= n*m && !isBlocked[i+m]){
            sys[i].push_back(i+m);
        }
        if(i%m != 0 && i+m <= n*m && !isBlocked[i+m+1]){
            sys[i].push_back(i+m+1);
        }
    }

    for(int i = 1; i <= n*m; i++){
        if(isBlocked[i]){
            continue;
        }
        dfs(i, 1, -1);
    }

    if(path_lenght < k){
        cout << -1 << endl;
        return 0;
    }
    path_find(lastV, path_lenght);
    cout << path_lenght << endl;
    while(!izh.empty()){
        cout << izh.top() << " ";
        izh.pop();
    }
    cout << endl;
return 0;
}
