/**
* user:  C039
* fname: Велислав Петров Гърков
* lname: СОФИЯ
* task:  dmaze
* score: 40.0
* date:  2019-05-11 07:04:16.641161
*/
#include <iostream>
using namespace std;
int n, m;
bool used[3010][3010];
int dp[3010][3010][3];
int mov[3][2]={{1,0},{0,1},{1,1}};
void setP(int p) {
    int i, j;
    i=p%n;
    j=p/n+1;
    if (i==0) {
        i=n;
        j--;
    }
    used[i][j]=true;
}
bool izliza(int i, int j) {
    if (i<1 || i>n || j<1 || j>m) return true;
    return false;
}
pair <int,int> dfs(int i, int j) {
    if (dp[i][j][0]>-1) return make_pair(dp[i][j][0],dp[i][j][1]);
    int x, y;
    pair <int,int> p;
    dp[i][j][0]=1;
    dp[i][j][1]=n*m+2;
    for (int k=0;k<3;k++) {
        x=i+mov[k][0];
        y=j+mov[k][1];
        if (izliza(x,y)) continue;
        if (!used[i][j]) p=dfs(x,y);
        if (p.first+1>dp[i][j][0] || (p.first+1==dp[i][j][0] && p.second<dp[i][j][1])) {
            dp[i][j][0]=p.first+1;
            dp[i][j][1]=p.second;
            dp[i][j][2]=x+(y-1)*n;
        }
    }
    if (dp[i][j][1]==n*m+2) dp[i][j][1]=i+(j-1)*n;
    return make_pair(dp[i][j][0],dp[i][j][1]);
}
int main () {
    int k, q, p, a, b, c;
    cin >> n >> m >> k;
    cin >> p >> q >> a >> b >> c;
    setP(q);
    for (int i=1;i<p;i++) {
        q=((q*a+b)%c)+1;
        setP(q);
    }
    pair <int,int> pa;
    for (int i=1;i<=n;i++) {
        for (int j=1;j<=m;j++) dp[i][j][0]=-1;
    }
    for (int i=1;i<=n;i++) {
        for (int j=1;j<=m;j++) {
            if (!used[i][j]) {
                pa=dfs(i,j);
                dp[i][j][0]=pa.first;
                dp[i][j][1]=pa.second;
            }
        }
    }
    int maxp, maxi, maxj;
    maxp=0;
    for (int i=1;i<=n;i++) {
        for (int j=1;j<=n;j++) {
            if (dp[i][j][0]>maxp || (dp[i][j][0]==maxp && dp[i][j][1]<maxi+(maxj-1)*n)) {
                maxp=dp[i][j][0];
                maxi=i;
                maxj=j;
            }
        }
    }
    if (maxp<k) {
        cout << -1 << endl;
        return 0;
    }
    int i, j;
    cout << maxp << endl;
    cout << maxi+(maxj-1)*n;
    while (dp[maxi][maxj][2]!=0) {
        i=maxi; j=maxj;
        maxi=dp[i][j][2]%n;
        maxj=dp[i][j][2]/n+1;
        if (maxi==0) {
            maxi=n;
            maxj--;
        }
        cout << ' ' << maxi+(maxj-1)*n;
    }
    cout << endl;
    return 0;
}
