/**
* user:  C040
* fname: Виктор Бориславов Михайлов
* lname: СОФИЯ
* task:  travel
* score: 4.0
* date:  2019-05-11 09:36:01.641251
*/
#include <bits/stdc++.h>

using namespace std;
#define sz(x) ((int)x.size())
#define pb push_back
#define all(x) x.begin() x.end()
#define rall(x) x.rbegin() x.rend()
typedef long long ll;
typedef unsigned long long ull;

const int MAX_N = 1e5+10;

int n, q;
vector<vector<int> > v;
bool used[MAX_N];
int dist[MAX_N];
bool f;
int ans, a, b, curr;
int ret;

struct A
{
    int a, b, c;
};

void bfs(int start, int to)
{
    fill_n(used + 0, n, false);
    fill_n(dist + 0, n, 0);
    vector<int> arr;
    arr.clear();
    int sz = 0;
    arr.push_back(start);
    used[start] = true;
    for (int i = 0; i < v[arr[0]].size(); ++ i)
    {
        dist[v[arr[0]][i]] = v[arr[0]][i] + 1;
        used[v[arr[0]][i]] = true;
        arr.push_back(v[arr[0]][i]);
    }
    ++ sz;
    while (sz != n)
    {
        for (int i = 0; i < v[arr[sz]].size(); ++ i)
        {
            if (!used[v[arr[sz]][i]])
            {
                used[v[arr[sz]][i]] = true;
                dist[v[arr[sz]][i]] = dist[arr[sz]];
                arr.push_back(v[arr[sz]][i]);
            }
        }
        ++ sz;
    }
    return;
}

bool cmp(A lhs, A rhs)
{
    if (lhs.a == rhs.a)
    {
        return lhs.b > rhs.b;
    }
    return lhs.a < rhs.a;
}

bool cmp2(pair<int, int> lhs, pair<int, int> rhs)
{
    return lhs.second < rhs.second;
}

int main()
{
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
    cin >> n >> q;
    v.resize(n);
    for (int i = 0; i < n - 1; ++ i)
    {
        cin >> a >> b;
        -- a;
        -- b;
        v[a].pb(b);
        v[b].pb(a);
    }
    int last;
    vector<A> za;
    for (int i = 0; i < q; ++ i)
    {
        ans = -1;
        ret = -1;
        cin >> a >> b;
        -- a;
        -- b;
        za.pb({a, b, i});
    }
    vector<pair<int, int> > ans;
    sort(za.begin(), za.end(), cmp);
    bfs(za[0].a, za[0].b);
    ans.push_back({dist[za[0].b], 0});
    for (int i = 1; i < q; ++ i)
    {
        if (za[i].a == za[i - 1].a)
        {
            ans.push_back({dist[za[i].b], za[i].c});
        }
        else
        {
            bfs(za[i].a, za[i].b);
            ans.push_back({dist[za[i].b], za[i].c});
        }
    }
    sort(ans.begin(), ans.end(), cmp2);
    for (int i = 0; i < q; ++ i)
    {
        cout << ans[i].first << endl;
    }
    return 0;
}
