/**
* user:  C044
* fname: Илия Светлинов Петров
* lname: СОФИЯ
* task:  travel
* score: 0.0
* date:  2019-05-11 06:47:02.897121
*/
#include <iostream>
#include <vector>

const int MAX_N = 1e5 + 10;

std::vector<int> nbrs[MAX_N];

int matrix[MAX_N][MAX_N];

std::vector<bool> used;

int query(int u, int v)
{
	if(matrix[u][v])
	{
		return matrix[u][v];
	}

	used[u] = true;
	
	for(int i = 0; i < nbrs[u].size(); ++ i)
	{
		int curr = nbrs[u][i];
		if(used[curr]) continue;
		int res = query(curr, v);
		if(res == 0)
		{
			matrix[curr][v] = u;
		}else
		{
			matrix[u][v] = curr;
			used[u] = false;
			return matrix[u][v];
		}
	}

	used[u] = false;
	return 0;
}

int main()
{
	std::cin.tie(NULL);
	std::cout.tie(NULL);
	std::ios_base::sync_with_stdio(false);

	for(int i = 0; i < MAX_N; ++ i)
	{
		matrix[i][i] = i;
	}

	int n, m;
	std::cin >> n >> m;

	used.resize(n + 1);

	for(int i = 1; i < n; ++ i)
	{
		int u, v;
		std::cin >> u >> v;
		nbrs[u].push_back(v);
		nbrs[v].push_back(u);
	}

	for(int i = 0; i < n; ++ i)
	{
		int u, v;
		std::cin >> u >> v;
		std::cout << query(u, v) << '\n';
	}

	return 0;
}