/**
* user:  C044
* fname: Илия Светлинов Петров
* lname: СОФИЯ
* task:  dmaze
* score: 100.0
* date:  2019-05-11 08:02:59.724125
*/
#include <iostream>
#include <stack>

const int MAX_N = 3100;

bool cant[MAX_N][MAX_N];
int ans[MAX_N][MAX_N];

std::stack<int> output;

int main()
{
	std::cin.tie(NULL);
	std::cout.tie(NULL);
	std::ios_base::sync_with_stdio(false);

	int n, m, k, p, q, a, b, c;
	std::cin >> n >> m >> k >> p >> q >> a >> b >> c;
	for(int l = 0; l < p; ++ l)
	{
		int i = q % n != 0 ? q % n : n;
		int j = (q + n - 1) / n;
		cant[i][j] = true;

		q = (a * q + b) % c + 1;
	}

	/*for(int i = 1; i <= n; ++ i)
	{
		for(int j = 1; j <= m; ++ j)
		{
			std::cout << cant[i][j];
		}
		std::cout << '\n';
	}*/

	int max = k - 1, maxi = 1e5, maxj = 1e5;

	for(int i = 1; i <= n; ++ i)
	{
		for(int j = 1; j <= m; ++ j)
		{
			if(cant[i][j])
			{
				ans[i][j] = 0;
				continue;
			}
			ans[i][j] = std::max(ans[i - 1][j], std::max(ans[i][j - 1], ans[i - 1][j - 1])) + 1;
			if(ans[i][j] > max || (ans[i][j] == max && (j - 1) * n + i < (maxj - 1) * n + maxi))
			{
				max = ans[i][j];
				maxi = i;
				maxj = j;
			}
		}
	}

	if(max < k)
	{
		std::cout << "-1\n";
		return 0;
	}

	output.push((maxj - 1) * n + maxi);

	while(ans[maxi][maxj] != 1)
	{
		if(ans[maxi - 1][maxj] == ans[maxi][maxj] - 1)
		{
			-- maxi;
			output.push((maxj - 1) * n + maxi);
			//std::cout << maxi << ' ' << maxj << '\n';
		}else if(ans[maxi][maxj - 1] == ans[maxi][maxj] - 1)
		{
			-- maxj;
			output.push((maxj - 1) * n + maxi);
			//std::cout << maxi << ' ' << maxj << '\n';
		}else
		{
			-- maxi;
			-- maxj;
			output.push((maxj - 1) * n + maxi);
			//std::cout << maxi << ' ' << maxj << '\n';
		}
	}

	std::cout << output.size() << '\n';

	while(!output.empty())
	{
		std::cout << output.top() << ' ';
		output.pop();
	}

	std::cout << '\n';

	return 0;
}