/**
* user:  C052
* fname: Юлиян Радославов Славчев
* lname: СОФИЯ
* task:  dmaze
* score: 80.0
* date:  2019-05-11 07:39:14.773133
*/
#include <bits/stdc++.h>
using namespace std;
#define endl '\n'
unordered_set<int> check;
int table[3001][3001];
int type[3001][3001];
const int GO_LEFT = 0;
const int GO_UP = 1;
const int GO_DIAGONAL = 2;
const int END = 3;
pair<int, int> dirs[] = {{-1, 0}, {0, -1}, {-1, -1}};
int rows, cols, p, k, q, a, b, c;
bool exist(int a, int b){
    return a >= 0 && b >= 0 && a < rows && b < cols;
}
int to_number(int a, int b){
    return a + 1 + b * rows;
}
int st[6000];
int back = -1;
bool empty(){ return back == -1;}
int top() {return st[back];}
void pop(){
    --back;
}
void push(int val){
    ++back;
    st[back] = val;
}
int main(){
    cin.tie(0);
    ios::sync_with_stdio(false);
    cin >> rows >> cols >> k >> p >> q >> a >> b >> c;
    check.insert(q);
    for(int i = 0; i < p - 1; ++i){
        int next = ((q * a + b) % c) + 1;
        q = next;
        check.insert(q);
    }
    int globalmax = 0;
    pair<int, int> maxindex = {5000, 5000};
    for(int i = 0; i < rows; ++i){
        for(int z = 0; z < cols; ++z){
            if(check.find(to_number(i, z)) != check.end()) continue;
            int maximum = 0;
            int maxdir = END;
            for(int l = 0; l < 3; ++l){
                int ni = i + dirs[l].first, nz = z + dirs[l].second;
                if(check.find(to_number(ni, nz)) != check.end()) continue;
                if(exist(ni, nz)){
                    if(table[ni][nz] > maximum){
                        maximum = table[ni][nz];
                        if(l == 0) maxdir = GO_UP;
                        if(l == 1) maxdir = GO_LEFT;
                        if(l == 2) maxdir = GO_DIAGONAL;
                    }
                }
            }
            ++maximum;
            //cout << maximum << ' ' << maxdir << ' ' << i << ' ' << z << ' ' << to_number(i, z) << endl;
            table[i][z] = maximum;
            type[i][z] = maxdir;
            if(maximum == globalmax && to_number(i, z) < to_number(maxindex.first, maxindex.second)){
                maxindex = {i, z};
            }
            if(maximum > globalmax) maxindex = {i, z};
            globalmax = max(globalmax, maximum);
        }
    }
    if(globalmax < k){
        cout << -1 << endl;
        return 0;
    }
    cout << globalmax << endl;
    while(true){
        push(to_number(maxindex.first, maxindex.second));
        if(type[maxindex.first][maxindex.second] == GO_UP) --maxindex.first;
        else if(type[maxindex.first][maxindex.second] == GO_LEFT) --maxindex.second;
        else if(type[maxindex.first][maxindex.second] == GO_DIAGONAL){
            --maxindex.first; --maxindex.second;
        }
        else if(type[maxindex.first][maxindex.second] == END) break;
    }
    while(!empty()){
        cout << top() << ' '; pop();
    }
    cout << endl;
    return 0;
}